Class.create(function(Super)
 /**
  * uEUEBhEOAy_[NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.log.browser.WindowLogAppenderNX
  * 
  * @package js.debug.log.browser
  * @update 2007/09/22
  * @version 2.00.00
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX̓uEUAɕʃEBhEɑ΂ẴOo͂邽߂̃Ay_[łB</p>
  * @explanation <p>̃NXŋK肷郍Oo͐ݒt@Cł̃p[^[͈ȉ̒ʂB
  *   <dl>
  *     <dt><kbd>name</kbd>ij</dt>
  *     <dd>EBhE܂̓t[</dd>
  *     <dt><kbd>wait</kbd></dt>
  *     <dd>EBhEJ܂ő҂(b/=Cȗ<var>Class.CREATE_WAIT_TIMEOUT</var>)</dd>
  *     <dt><var>window.open</var>\bh̃IvV(R)̃p[^[</dt>
  *     <dd>̃p[^[ݒ\łB<kbd>titlebar,menubar,toolbar,location,directories,status,scrollbars,resizable,width,height,left,top</kbd></dd>
  *   </dl>
  *   ȂAȊOɂX[p[NX(<var>BrowserLogAppender</var>)Œ`ꂽp[^[ݒ\łB</p>
  * @rel js.debug.log.browser.BrowserLogAppender
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.log.browser.WindowLogAppender";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V CREATE_WAIT_TIMEOUT_DEFAULT Number EBhẼ^CAEgb̃ftHgl
  var CREATE_WAIT_TIMEOUT_DEFAULT = 10;
  
  //------------------------------------------------------------------------------
  function createOptions(params)
   /**
    * EBhEIvV쐬
    * @param params Object p[^[(String)}bv
    * @return String EBhEIvV
    */
    {
    // l̎擾
    var titlebar    = Static.parseParams(params, "titlebar"   , "yes", "string");
    var menubar     = Static.parseParams(params, "menubar"    , "yes", "string");
    var toolbar     = Static.parseParams(params, "toolbar"    , "no" , "string");
    var location    = Static.parseParams(params, "location"   , "no" , "string");
    var directories = Static.parseParams(params, "directories", "no" , "string");
    var status      = Static.parseParams(params, "status"     , "yes", "string");
    var scrollbars  = Static.parseParams(params, "scrollbars" , "yes", "string");
    var resizable   = Static.parseParams(params, "resizable"  , "yes", "string");
    var width       = Static.parseParams(params, "width"      ,  null, "number");
    var height      = Static.parseParams(params, "height"     ,  null, "number");
    var left        = Static.parseParams(params, "left"       ,  null, "number");
    var top         = Static.parseParams(params, "top"        ,  null, "number");
    // 쐬
    var options = "titlebar=" + titlebar;
    options += ",menubar="     + menubar;
    options += ",toolbar="     + toolbar;
    options += ",location="    + location;
    options += ",directories=" + directories;
    options += ",status="      + status;
    options += ",scrollbars="  + scrollbars;
    options += ",resizable="   + resizable;
    if(width)
      {
      options += ",width=" + width;
      }
    if(height)
      {
      options += ",height=" + height;
      }
    if(left)
      {
      options += ",left="    + left;
      options += ",screenX=" + left;
      }
    if(top)
      {
      options += ",top="     + top;
      options += ",screenY=" + top;
      }
    return options;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  //:C CREATE_WAIT_TIMEOUT Number EBhẼ^CAEgb
  Class.CREATE_WAIT_TIMEOUT = CREATE_WAIT_TIMEOUT_DEFAULT;
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Static.create = function(params)
   /**
    * Oo͐쐬
    * @param params Object p[^[(String)}bv
    * @return Object ReiIuWFNg(TuEBhE)
    * @throw TimeoutIoException EBhEANZX^CAEgꍇ
    */
    {
    var now  = (new Date()).getTime();
    var src  = "about:blank";
    var name = Static.parseParams(params, "name", ("LogWindow_" + now), "string");
    var opt  = createOptions(params);
    var wait = ((typeof Class.CREATE_WAIT_TIMEOUT) == "number") ? Class.CREATE_WAIT_TIMEOUT : CREATE_WAIT_TIMEOUT_DEFAULT;
    wait = Static.parseParams(params, "wait", wait, "number");
    var limit = wait * 1000 + now;
    var win = window.open(src, name, opt);
    if(win)
      {
      var isLoad = false;
      while((wait < 0) || ((new Date()).getTime() < limit))
        {
        try
          {
          if(win && !win.closed && win.document && win.document.body)
            {
            isLoad = true;
            break;
            }
          }
        catch(e)
          {
          // ignore.
          }
        }
      if(!isLoad)
        {
        throw new Error("SecurityException", Creator.CompleteName, "JEBhE(" + name + ")ɑ΂A(" + wait + "sec)ɃANZXł܂łB");
        }
      }
    else
      {
      throw new Error("SecurityException", Creator.CompleteName, "EBhE(" + name + ")J܂łB");
      }
    return win;
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(params)
   /**
    * WindowLogAppenderNX̃RXgN^
    * @param params Object p[^[(String)}bv
    * @return js.debug.log.browser.window.WindowLogAppender CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    return this;
    }
  
  return Class;
  }, js.debug.log.browser.BrowserLogAppender);

