Class.create(function(Super)
 /**
  * ۃOAy_[NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.log.AbstractLogAppenderNX
  * 
  * @package js.debug.log
  * @update 2007/09/22
  * @version 2.00.00
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX<var>AbstractLogStocker</var>̃TuNXɃXgbNꂽOf[^
  *   ۂɏo͂邽߂̒ۃNXłBo͂̂߂̎菇͂̃NXŎĂA
  *   TuNXł͉<var>prototype</var>̃\bhłA
  *   <var>exists</var>,<var>isAlive</var>,<var>create</var>,<var>open</var>,<var>print</var>,<var>close</var>
  *   I[o[ChĎȂ΂ȂȂB</p>
  *   <p>I[o[ChĎׂ\bh̖͈ȉ̒ʂB
  *   <ul>
  *     <li><var>exists</var>FOo͐悪݂i쐬ς݁j𔻒肷B</li>
  *     <li><var>isAlive</var>FOo͐悪gp\i쐬ς݂ŊJԁj𔻒肷B</li>
  *     <li><var>create</var>FOo͐쐬B</li>
  *     <li><var>open</var>FOo͐JB</li>
  *     <li><var>print</var>FOf[^PۂɒǋLB</li>
  *     <li><var>close</var>FOo͐B</li>
  *   </ul></p>
  * @explanation <p>̃NXŋK肷郍Oo͐ݒt@Cł̃p[^[͈ȉ̒ʂB
  *   <dl>
  *     <dt><kbd>format</kbd>iCӁj</dt>
  *     <dd>ÕtH[}bgi{date},{time},{key},{level},{text}ujCX^XƂɐݒłB</dd>
  *   </dl></p>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.log.AbstractLogAppender";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.debug.log.LogStockData
  var LogStockData = js.debug.log.LogStockData;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  function parseParams(params, name, defaultValue, valueMap)
   /**
    * p[^[͂
    * @param params [Object|null] p[^[IuWFNg(String̃}bv)
    * @param name String p[^[
    * @param defaultValue Variant ftHgl
    * @param valueMap [Object|null] ԋpl̃}bv(L[:p[^[l/l:ԋpl)
    * @return Variant ftHgl܂̓}bv̕ԋpl
    */
    {
    if(((typeof params) == "object") && ((typeof name) == "string"))
      {
      // w̃p[^[Ȃꍇ
      if((params[name] === undefined) && !params.hasOwnProperty(name))
        {
        return defaultValue;
        }
      // p[^[l擾
      var value = params[name];
      // z擾
      if(((typeof valueMap) == "string") && (valueMap.length > 2) && (valueMap.indexOf("[]", 0) == (valueMap.length - 2)))
        {
        valueMap = valueMap.substring(0, (valueMap.length - 2));
        var ret = [];
        if(value instanceof ret.constructor)
          {
          for(var i = 0; i < value.length; i++)
            {
            ret[i] = getValue(value[i], valueMap);
            }
          }
        else
          {
          ret[0] = getValue(value, valueMap);
          }
        return ret;
        }
      // P擾
      else
        {
        return getValue(value, valueMap);
        }
      // lϊ\bh
      function getValue(value, valueMap)
        {
        // ɕϊ
        if((typeof value) != "string")
          {
          value = "" + value;
          }
        // }bvw
        if(((typeof valueMap) == "object") && valueMap.hasOwnProperty(value))
          {
          return valueMap[value];
          }
        // ^Uw
        else if(valueMap == "boolean")
          {
          if(value.toLowerCase() == "true")
            {
            return true;
            }
          else if(value.toLowerCase() == "false")
            {
            return false;
            }
          }
        // lw
        else if(valueMap == "number")
          {
          var num = parseFloat(value);
          if(!isNaN(num))
            {
            return num;
            }
          }
        // w
        else if(valueMap == "string")
          {
          return value;
          }
        return defaultValue;
        }
      }
    return defaultValue;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S LOG_FORMAT String OtH[}bg(ftHg)
  Static.LOG_FORMAT = "{date} {time}[{level}]{key} {text}";
  
  //------------------------------------------------------------------------------
  //:S parseParams Function p[^[͂(parseParams̎Q)
  Static.parseParams = parseParams;
  //------------------------------------------------------------------------------
  Static.parseLogData2Format = function(data, format)
   /**
    * Of[^w̃tH[}bgɊÂĕɕϊ
    * @param data js.debug.log.LogStockData Of[^
    * @param format [String|null] OtH[}bg(null܂͏ȗAbstractLogAppender.Static.LOG_FORMAT𗘗p)
    * @return String O
    * @throw FormatException@Error datajs.debug.log.LogStockDatãCX^XłȂꍇ
    * @throw StringFormatException@Error formatnullł`łv~eBuString^łȂꍇ
    */
    {
    if(!data || !(data instanceof LogStockData))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"data", format:"js.debug.log.LogStockData", value:data, type:(typeof data)});
      }
    if((format != null) && (format !== undefined) && ((typeof format) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, {variable:"format", value:format, type:(typeof format)});
      }
    if((format == null) || (format == undefined))
      {
      format = Static.LOG_FORMAT;
      }
    // f[^
    var date = data.getDateString();
    var time = data.getTimeString();
    var key = data.src;
    var lev = data.level;
    var val = data.values;
    var msg = "";
    switch(typeof val)
      {
      case "object":
        if(val && ((typeof val.length) == "number"))
          {
          for(var i = 0; i < val.length; i++)
            {
            msg += val[i];
            }
          break;
          }
      case "string":
      case "number":
      case "boolean":
      case "function":
      case "undefined":
      default:
        msg += val;
      }
    // u
    var text = format;
    text = text.replace(/\{date\}/gi, date);
    text = text.replace(/\{time\}/gi, time);
    text = text.replace(/\{key\}/gi, key);
    text = text.replace(/\{level\}/gi, lev);
    text = text.replace(/\{text\}/gi, msg);
    return text;
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P format String ̃NX̃ftHg̃OtH[}bg
  Proto.format = Static.LOG_FORMAT;
  
  //------------------------------------------------------------------------------
  Proto.exists = function()
   /**
    * Ay_[悪݂邩ǂ擾
    * @explanation Ay_[݂邩(KvȂcreateĂ邩)ǂB
    * @notice ̃\bh̓TuNXŃI[o[ChȂ΂ȂȂB
    * @return Boolean Ay_[悪gp\ǂ
    * @throw SystemError@Error TuNXł̃\bhI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "js.debug.log.AbstractLogAppender.prototype.exists\bhTuNXŃI[o[ChĂ܂B");
    };
  //------------------------------------------------------------------------------
  Proto.isAlive = function()
   /**
    * Ay_[悪gp\ǂ擾
    * @explanation Ay_[(KvȂcreate)openꂽԂł邩ǂB
    * @notice ̃\bh̓TuNXŃI[o[ChȂ΂ȂȂB
    * @return Boolean Ay_[悪gp\ǂ
    * @throw SystemError@Error TuNXł̃\bhI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "js.debug.log.AbstractLogAppender.prototype.isAlive\bhTuNXŃI[o[ChĂ܂B");
    };
  //------------------------------------------------------------------------------
  Proto.create = function()
   /**
    * Ay_[쐬
    * @explanation Ay_[JOɍ쐬KvꍇɎsB
    * @notice ̃\bh̓TuNXŃI[o[ChȂ΂ȂȂB
    * @throw SystemError@Error TuNXł̃\bhI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "js.debug.log.AbstractLogAppender.prototype.create\bhTuNXŃI[o[ChĂ܂B");
    };
  //------------------------------------------------------------------------------
  Proto.open = function()
   /**
    * Ay_[J
    * @explanation Ay_[JOɍ쐬Kvꍇ́Acreate\bhsB
    * @notice ̃\bh̓TuNXŃI[o[ChȂ΂ȂȂB
    * @throw SystemError@Error TuNXł̃\bhI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "js.debug.log.AbstractLogAppender.prototype.open\bhTuNXŃI[o[ChĂ܂B");
    };
  //------------------------------------------------------------------------------
  Proto.append = function(data)
   /**
    * Oǉ
    * @explanation <p>̃\bh͕KvɉăTuNXŃI[o[ChB
    *   ftHgł́Aȉ̎ƂȂĂB
    *   <ol>
    *     <li><kbd>this.isAlive()</kbd>sAtrueȂ5AfalseȂ瑱2sB</li>
    *     <li><kbd>this.exists()</kbd>sAtrueȂ4AfalseȂ瑱3sB</li>
    *     <li><kbd>this.create()</kbd>sB</li>
    *     <li><kbd>this.open()</kbd>sB</li>
    *     <li><var>data</var>擪ƂLogStockData^̃`F[̊evfɂāAȉ67sB</li>
    *     <li>evf<var>this.format</var>ɂāA<kbd>this.constructor.Static.parseLogData2Format()</kbd>sB</li>
    *     <li>6̖߂l<kbd>this.print()</kbd>sB</li>
    *   </ol></p>
    * @param data js.debug.log.LogStockData Of[^
    * @throw FormatError@Error datajs.debug.log.LogStockData^łȂꍇ
    * @throw Error this.exists,this.isAlive,this.create,this.open,this.print̊e\bhG[X[ꂽꍇĩ\bhł͕ߑȂj
    */
    {
    if(!(data instanceof LogStockData))
      {
      throw new Error("FormatError", Creator.CompleteName, {variable:data, format:"js.debug.log.LogStockData", value:data, type:(typeof data)});
      }
    if(!this.isAlive())
      {
      if(!this.exists())
        {
        this.create();
        }
      this.open();
      }
    for(var target = data; target; target = target.next)
      {
      this.print(this.constructor.Static.parseLogData2Format(target, (((typeof this.format) == "string") ? this.format : null)));
      }
    };
  //------------------------------------------------------------------------------
  Proto.print = function(text)
   /**
    * OP
    * @notice ̃\bh̓TuNXŃI[o[ChȂ΂ȂȂB
    * @param text String Oo͕
    * @throw SystemError@Error TuNXł̃\bhI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "js.debug.log.AbstractLogAppender.prototype.print\bhTuNXŃI[o[ChĂ܂B");
    };
  //------------------------------------------------------------------------------
  Proto.close = function()
   /**
    * Ay_[
    * @notice ̃\bh̓TuNXŃI[o[ChȂ΂ȂȂB
    * @throw SystemError@Error TuNXł̃\bhI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "js.debug.log.AbstractLogAppender.prototype.close\bhTuNXŃI[o[ChĂ܂B");
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(params)
   /**
    * AbstractLogAppenderNX̃RXgN^
    * @param params [Object] p[^[(String)}bv
    * @return js.debug.log.AbstractLogAppender CX^X
    * @throw SystemError@Error ̃NX̃TuNXnewĊԐړIɌĂяoĂȂꍇ
    */
    {
    if(!(this instanceof Class) || (this.constructor == Class))
      {
      throw new Error("SystemError", Creator.CompleteName, "AbstractLogAppender̃TuNXnewȂ΂Ȃ܂B");
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    // format̐ݒ
    var format = Static.parseParams(params, "format", null, "string");
    if(format != null)
      {
      /**
       * CX^XŗL̃OtH[}bg
       * @def i
       * @name format
       * @type [String]
       * @explanation p[^[ŎŵƂ̂ݐݒ肳B
       */
      this.format = format;
      }
    return this;
    }
  
  return Class;
  });

