Class.create(function(Super)
 /**
  * uEUOAy_[ۃNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.log.browser.BrowserLogAppenderNX
  * 
  * @package js.debug.log.browser
  * @update 2007/09/22
  * @version 2.00.00
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX̓uEUɑ΂ẴOo͂邽߂̃Ay_[łB
  *   TuNXł<var>Static</var><var>create</var>\bhI[o[ChĎȂ΂ȂȂB</p>
  * @explanation <p>̃NXŋK肷郍Oo͐ݒt@Cł̃p[^[͈ȉ̒ʂB
  *   <dl>
  *     <dt><kbd>title</kbd>ij</dt>
  *     <dd>hLg̃^Cg</dd>
  *     <dt><kbd>style</kbd>iCӁj</dt>
  *     <dd>body^ÕX^CV[g</dd>
  *     <dt><kbd>scroll</kbd>iCӁj</dt>
  *     <dd>Oõ͎XN[v(true|false)</dd>
  *   </dl>
  *   ȂAȊOɂX[p[NX(<var>AbstractLogAppender</var>)Œ`ꂽp[^[ݒ\łB</p>
  * @rel js.debug.log.AbstractLogAppender
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.log.browser.BrowserLogAppender";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.debug.log.LogStockData
  var LogStockData = js.debug.log.LogStockData;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  function escapeTags(str)
   /**
    * ^OGXP[v
    * @explanation <p>̃\bhł͈ȉ̕ϊsB
    *   <ul>
    *     <li>&amp;&amp;amp;</li>
    *     <li>&lt;&amp;lt;</li>
    *     <li>&gt;&amp;gt;</li>
    *     <li>&quot;&amp;quot;</li>
    *     <li>p󔒁&amp;nbsp;</li>
    *     <li>\t&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;</li>
    *     <li>\r󕶎i폜j</li>
    *     <li>\n&lt;br /&gt;\r\n</li>
    *   </ul></p>
    * @notice ^łȂꍇ́AɕϊB
    * @param str String ̕
    * @return String GXP[v̕
    */
    {
    if((typeof str) != "string")
      {
      str = "" + str;
      }
    str = str.replace(/&/g, "&amp;");
    str = str.replace(/</g, "&lt;");
    str = str.replace(/>/g, "&gt;");
    str = str.replace(/"/g, "&quot;");
    str = str.replace(/ /g, "&nbsp;");
    str = str.replace(/\t/g, "&nbsp;&nbsp;&nbsp;&nbsp;");
    str = str.replace(/\r/g, "");
    str = str.replace(/\n/g, "<br />\r\n");
    return str;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S LOG_FORMAT String OtH[}bg(I[o[Ch)
  Static.LOG_FORMAT = '<div>' + escapeTags(Super.Static.LOG_FORMAT.replace(/\t/g, " ")) + '</div>';
  
  //:S LOG_LEVELS Object Ox̃}bviϊpj
  Static.LOG_LEVELS = {};
  // LOG_LEVELS.FATAL = <wiF:, F:, C:>
  Static.LOG_LEVELS["FATAL"] = '<span style="background-color:red;color:white;font-weight:bold;">FATAL</span>';
  // LOG_LEVELS.ERROR = <wiF:, F:, C:>
  Static.LOG_LEVELS["ERROR"] = '<span style="background-color:white;color:red;font-weight:bold;">ERROR</span>';
  // LOG_LEVELS.WARN  = <wiF:, F:, C:ʏ>
  Static.LOG_LEVELS["WARN"]  = '<span style="background-color:white;color:orange;font-weight:normal;margin:0px 0.5ex;">WARN</span>';
  // LOG_LEVELS.INFO  = <wiF:, F:, C:>
  Static.LOG_LEVELS["INFO"]  = '<span style="background-color:white;color:black;font-weight:bold;margin:0px 0.5ex;">INFO</span>';
  // LOG_LEVELS.DEBUG = <wiF:, F:, C:ʏ>
  Static.LOG_LEVELS["DEBUG"] = '<span style="background-color:white;color:black;font-weight:normal;">DEBUG</span>';
  // LOG_LEVELS.TRACE = <wiF:, F:D, C:ʏ>
  Static.LOG_LEVELS["TRACE"] = '<span style="background-color:white;color:gray;font-weight:normal;">TRACE</span>';
  
  //------------------------------------------------------------------------------
  Static.parseLogData2Format = function(data, format, withoutEscape)
   /**
    * Of[^w̃tH[}bgɊÂĕɕϊ
    * @notice X[p[NX̃\bhbvAOo͂𕶎񉻂āA^OGXP[vB
    * @explanation GXP[vɏo͂TuNXł́Ã\bhbvA
    *              Super.Static.parseLogData2Format(data, format, true); return΂悢B
    * @param data js.debug.log.LogStockData Of[^
    * @param format [String] OtH[}bg
    * @param withoutEscape [Boolean] ^ÕGXP[vȂŏo͂邩ǂ(true:^OGXP[vȂ/false,ȗ:GXP[v)
    * @return String O
    * @throw FormatException@Error datajs.debug.log.LogStockDatãCX^XłȂꍇ
    * @throw StringFormatException@Error formatnullł`łv~eBuString^łȂꍇ
    * @throw BooleanFormatException@Error withoutEscape`łv~eBuBoolean^łȂꍇ
    */
    {
    if(!data || !(data instanceof LogStockData))
      {
      throw new Error("FormatException", Creator.CompleteName, {variable:"data", format:"js.debug.log.LogStockData", value:data, type:(typeof data)});
      }
    if((format != null) && (format !== undefined) && ((typeof format) != "string"))
      {
      throw new Error("StringFormatException", Creator.CompleteName, {variable:"format", value:format, type:(typeof format)});
      }
    if((withoutEscape !== undefined) && ((typeof withoutEscape) != "boolean"))
      {
      throw new Error("BooleanFormatException", Creator.CompleteName, {variable:"withoutEscape", value:withoutEscape, type:(typeof withoutEscape)});
      }
    if(data.level && Static.LOG_LEVELS && ((typeof Static.LOG_LEVELS[data.level]) == "string"))
      {
      data.level = Static.LOG_LEVELS[data.level];
      }
    if(data.values && !withoutEscape)
      {
      switch(typeof data.values)
        {
        case "object":
          if(data.values && ((typeof data.values.length) == "number"))
            {
            for(var i = 0; i < data.values.length; i++)
              {
              data.values[i] = escapeTags(data.values[i]);
              }
            break;
            }
        case "string":
        case "number":
        case "boolean":
        case "function":
        case "undefined":
        default:
          data.values = escapeTags(data.values);
        }
      }
    return Super.Static.parseLogData2Format(data, format);
    };
  //------------------------------------------------------------------------------
  Static.create = function(params)
   /**
    * Oo͐쐬
    * @notice ̃\bh̓TuNXŃI[o[ChȂ΂ȂȂB
    *   TuNX́AReiɊSɃANZXł悤ɂȂĂI邩A
    *   ^CAEg̏ꍇ̓G[X[Ȃ΂ȂȂB
    * @param params [Object] p[^[(String)}bv
    * @return Object ReiIuWFNg(EBhE܂̓t[)
    * @throw SystemError@Error TuNXł̃\bhI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "TuNXłBrowserLogAppender.Static.create\bhI[o[ChȂ΂Ȃ܂B");
    };
  //------------------------------------------------------------------------------
  Static.open = function(container, title, style)
   /**
    * Oo͐J
    * @param container Object ReiIuWFNg(EBhE܂̓t[)
    * @param title [String|null] ^Cg
    * @param style [String|null] X^CV[g(body^Ô)
    */
    {
    var src = container.document.body.innerHTML;
    container.document.clear();
    container.document.open();
    container.document.writeln('<html>');
    container.document.writeln('<head>');
    container.document.writeln('<meta http-equiv="Content-Type" content="text/html; charset=Unicode" />');
    //container.document.writeln('<meta http-equiv="Content-Script-Type" content="text/javascript" />');
    container.document.writeln('<meta http-equiv="Content-Style-Type" content="text/css" />');
    if(title)
      {
      if((title.indexOf("\n", 0) >= 0) || (title.indexOf("\r", 0) >= 0))
        {
        title = title.replace(/\n|\r/g, "");
        }
      container.document.writeln('<title>' + escapeTags(title) + '</title>');
      container.document.title = title;
      }
    container.document.writeln('</head>');
    if(style)
      {
      if((style.indexOf("\n", 0) >= 0) || (style.indexOf("\r", 0) >= 0))
        {
        style = style.replace(/\n|\r/g, "");
        }
      container.document.writeln('<body style="' + escapeTags(style) + '">');
      container.document.body.style.cssText = style;
      }
    else
      {
      container.document.writeln('<body>');
      }
    if(src)
      {
      container.document.writeln(src);
      }
    };
  //------------------------------------------------------------------------------
  Static.print = function(container, text)
   /**
    * OǋL
    * @param container Object ReiIuWFNg(EBhE܂̓t[)
    * @param text String O
    */
    {
    container.document.writeln(text);
    };
  //------------------------------------------------------------------------------
  Static.close = function(container)
   /**
    * Oo͐
    * @param container Object ReiIuWFNg(EBhE܂̓t[)
    */
    {
    container.document.writeln('</body>');
    container.document.writeln('</html>');
    container.document.close();
    };
  //------------------------------------------------------------------------------
  //:S escapeTags Function ^OGXP[v
  Static.escapeTags = escapeTags;
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P format String ̃NX̃ftHg̃OtH[}bg
  Proto.format = Static.LOG_FORMAT;
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(params)
   /**
    * BrowserLogAppenderNX̃RXgN^
    * @param params Object p[^[(String)}bv
    * @return js.debug.log.browser.BrowserLogAppender CX^X
    * @throw SystemError@Error ̃NX̃TuNXnewĊԐړIɌĂяoĂȂꍇ
    */
    {
    if(!(this instanceof Class) || (this.constructor == Class))
      {
      throw new Error("SystemError", Creator.CompleteName, "BrowserLogAppender̃TuNXnewȂ΂Ȃ܂B");
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v container Object|null ReiIuWFNg(EBhE܂̓t[)
    var container = null;
    //:v title String|null hLg̃^Cg
    var title = null;
    //:v style String|null body^ÕX^CV[g
    var style = null;
    //:v scroll Boolean Oõ͎XN[v
    var scroll = true;
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.exists = function()
     /**
      * Ay_[悪݂邩ǂ擾
      * @explanation Ay_[݂邩(KvȂcreateĂ邩)ǂB
      * @return Boolean Ay_[悪gp\ǂ
      */
      {
      var exist = false;
      try
        {
        exist = ((container && !container.closed) && container.document);
        }
      catch(e)
        {
        exist = false;
        }
      return exist;
      };
    //------------------------------------------------------------------------------
    this.isAlive = function()
     /**
      * Ay_[悪gp\ǂ擾
      * @explanation Ay_[(KvȂcreate)openꂽԂł邩ǂB
      * @return Boolean Ay_[悪gp\ǂ
      */
      {
      var alive = false;
      try
        {
        alive = (container.document.body && container.isOpened);
        }
      catch(e)
        {
        alive = false;
        }
      return alive;
      };
    //------------------------------------------------------------------------------
    this.create = function()
     /**
      * Ay_[쐬
      * @explanation Ay_[JOɍ쐬KvꍇɎsB
      * @notice ̃\bh́AReiɊSɃANZXł悤ɂȂĂI邩A
      *   ^CAEg̏ꍇ̓G[X[B
      * @throw Error Ay_[쐬łȂꍇ
      */
      {
      container = this.constructor.Static.create(params);
      };
    //------------------------------------------------------------------------------
    this.open = function()
     /**
      * Ay_[J
      * @explanation Ay_[JOɍ쐬Kvꍇ́Acreate\bhsB
      */
      {
      this.constructor.Static.open(container, title, style);
      container.isOpened = true;
      };
    //------------------------------------------------------------------------------
    this.print = function(text)
     /**
      * OP
      * @param text String Oo͕
      */
      {
      this.constructor.Static.print(container, text);
      if(scroll)
        {
        container.window.scrollTo(0, Math.max(container.document.body.scrollHeight, container.document.body.offsetHeight));
        }
      };
    //------------------------------------------------------------------------------
    this.close = function()
     /**
      * Ay_[
      */
      {
      if(this.isAlive())
        {
        this.constructor.Static.close(container);
        container.isOpened = false;
        container = null;
        }
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    title  = Static.parseParams(params, "title" , title , "string");
    style  = Static.parseParams(params, "style" , style , "string");
    scroll = Static.parseParams(params, "scroll", scroll, "boolean");
    return this;
    }
  
  return Class;
  }, js.debug.log.AbstractLogAppender);

