Class.create(function(Super)
 /**
  * f[^x[XOAy_[ۃNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.log.db.DatabaseLogAppenderNX
  * 
  * @package js.debug.log.db
  * @update 2007/09/22
  * @version 1.00.00
  * @author Mug
  * @copyright (C) 2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX̓f[^x[XփOo͂邽߂̃Ay_[łB
  *   TuNXł<var>Static</var><var>createSource</var>\bhI[o[ChĎȂ΂ȂȂB</p>
  * @explanation <p>̃NXŋK肷郍Oo͐ݒt@Cł̃p[^[͈ȉ̒ʂB
  *   <dl>
  *     <dt><kbd>format</kbd><em>iK{j</em></dt>
  *     <dd>ÔrpktH[}bgi{date},{time},{key},{level},{text}ujo͐ɍ킹rpkɐݒ肷B<br />
  *       ij<samp style="background-color:silver;">INSERT INTO SCREEN_LOG_DATA (TIMESTAMP, SOURCE, LEVEL, TEXT) VALUES ('{date} {time}', '{key}', '{level}', '{text}')</samp>
  *     </dd>
  *     <dt><kbd>text-length</kbd>ij</dt>
  *     <dd>tH[}bg{text}̍ő勖eB̕𒴉߂ꍇÃOɕB</dd>
  *   </dl>
  *   ȂAX[p[NX(<var>AbstractLogAppender</var>)Œ`ꂽp[^[ݒ\łB</p>
  * @rel js.debug.log.AbstractLogAppender
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.log.db.DatabaseLogAppender";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Static.createSource = function(params)
   /**
    * p[^[ADO̐ڑ𐶐
    * @param params [Object] p[^[
    * @return String ADO̐ڑ
    * @throw SystemError@Error TuNXł̃\bhI[o[ChĂȂꍇ
    */
    {
    throw new Error("SystemError", Creator.CompleteName, "js.debug.log.db.DatabaseLogAppender.Static.createSource\bhTuNXŃI[o[ChĂ܂B");
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.exists = function()
   /**
    * Ay_[悪݂邩ǂ擾
    * @return Boolean Ay_[悪gp\ǂ
    */
    {
    return true;
    };
  //------------------------------------------------------------------------------
  Proto.create = function()
   /**
    * Ay_[쐬
    */
    {
    // Do nothing.
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(params)
   /**
    * DatabaseLogAppenderNX̃RXgN^
    * @param params Object p[^[(String)}bv
    * @return js.debug.log.db.DatabaseLogAppender CX^X
    * @throw SystemError@Error ̃NX̃TuNXnewĊԐړIɌĂяoĂȂꍇ
    */
    {
    if(!(this instanceof Class) || (this.constructor == Class))
      {
      throw new Error("SystemError", Creator.CompleteName, "DatabaseLogAppender̃TuNXnewȂ΂Ȃ܂B");
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v source String|null ADO̐ڑ
    var source = null;
    //:v conn Object|null f[^x[Xڑ
    var conn = null;
    
    //:v textLength Number|null tH[}bg{text}̃TCY()
    var textLength = null;
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.isAlive = function()
     /**
      * Ay_[悪gp\ǂ擾
      * @explanation Ay_[(KvȂcreate)openꂽԂł邩ǂB
      * @return Boolean Ay_[悪gp\ǂ
      */
      {
      return !!conn;
      };
    //------------------------------------------------------------------------------
    this.open = function()
     /**
      * Ay_[J
      * @explanation Ay_[JOɍ쐬Kvꍇ́Acreate\bhsB
      */
      {
      if(!this.isAlive())
        {
        conn = new ActiveXObject("ADODB.Connection");
        conn.Open(source);
        }
      };
    //------------------------------------------------------------------------------
    this.append = function(data)
     /**
      * Oǉ
      * @param data js.debug.log.LogStockData Of[^
      * @throw FormatError@Error datajs.debug.log.LogStockData^łȂꍇ
      */
      {
      if(!(data instanceof LogStockData))
        {
        throw new Error("FormatError", Creator.CompleteName, {variable:data, format:"js.debug.log.LogStockData", value:data, type:(typeof data)});
        }
      if(((typeof textLength) == "number") && (textLength > 0))
        {
        var val = data.values;
        var msg = "";
        switch(typeof val)
          {
          case "object":
            if(val && ((typeof val.length) == "number"))
              {
              for(var i = 0; i < val.length; i++)
                {
                msg += val[i];
                }
              break;
              }
          case "string":
          case "number":
          case "boolean":
          case "function":
          case "undefined":
          default:
            msg += val;
          }
        if(msg.length > textLength)
          {
          for(var e = textLength; e < msg.length; e += textLength)
            {
            data.values = msg.substring((e - textLength), e);
            Super.prototype.append.apply(this, arguments);
            }
          data.values = msg.substring((e - textLength), msg.length);
          Super.prototype.append.apply(this, arguments);
          }
        else
          {
          Super.prototype.append.apply(this, arguments);
          }
        }
      else
        {
        Super.prototype.append.apply(this, arguments);
        }
      };
    //------------------------------------------------------------------------------
    this.print = function(text)
     /**
      * OP
      * @param text String Oo͕(SQL)
      */
      {
      conn.Execute(text);
      };
    //------------------------------------------------------------------------------
    this.close = function()
     /**
      * Ay_[
      */
      {
      if(this.isAlive())
        {
        conn.Close();
        conn = null;
        }
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    source = this.constructor.Static.createSource(params);
    textLength = Static.parseParams(params, "text-length", textLength, "number");
    return this;
    }
  
  return Class;
  }, js.debug.log.AbstractLogAppender);

