Class.create(function(Super)
 /**
  * t@COAy_[NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.log.file.FileLogAppenderNX
  * 
  * @package js.debug.log.file
  * @update 2007/09/22
  * @version 2.00.00
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX̓t@Cɑ΂ẴOo͂邽߂̃Ay_[łB
  *   ݂ActiveXgpĂ邽߁AHTA܂WSHŎgp\łB</p>
  * @explanation <p>̃NXŋK肷郍Oo͐ݒt@Cł̃p[^[͈ȉ̒ʂB
  *   <dl>
  *     <dt><kbd>fileName</kbd><em>iK{j</em></dt>
  *     <dd>t@CipX܂߂Ă悢j</dd>
  *     <dt><kbd>charset</kbd>iCӁj</dt>
  *     <dd>R[h(ASCII|Unicode)iShift_JISASCIIwj</dd>
  *     <dt><kbd>lineSeparator</kbd>iCӁj</dt>
  *     <dd>sR[h(CR|LF|CRLF|LFCR)</dd>
  *     <dt><kbd>openMode</kbd>iCӁj</dt>
  *     <dd>o̓[h(rewrite|append)</dd>
  *   </dl>
  *   ȂAȊOɂX[p[NX(<var>AbstractLogAppender</var>)Œ`ꂽp[^[ݒ\łB</p>
  * @rel js.debug.log.AbstractLogAppender
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.log.file.FileLogAppender";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(params)
   /**
    * FileLogAppenderNX̃RXgN^
    * @param params Object p[^[(String)}bv
    * @return js.debug.log.file.FileLogAppender CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v fso ActiveXObject FileSystemObject
    var fso = new ActiveXObject("Scripting.FileSystemObject");
    //:v writer Object|null C^[
    var writer = null;
    
    //:v fileName String|null t@C
    var fileName = null;
    //:v charset Number R[h(0:ASCII/-1:Unicode/-2:VXeftHg)
    var charset = -2;
    //:v lineSeparator String|null sR[h
    var lineSeparator = null;
    //:v openMode Number o̓[h(2:ݐp/8:ǋLp)
    var openMode = 8;
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.exists = function()
     /**
      * Ay_[悪݂邩ǂ擾
      * @explanation Ay_[݂邩(KvȂcreateĂ邩)ǂB
      * @return Boolean Ay_[悪gp\ǂ
      */
      {
      return fso.FileExists(fileName);
      };
    //------------------------------------------------------------------------------
    this.isAlive = function()
     /**
      * Ay_[悪gp\ǂ擾
      * @explanation Ay_[(KvȂcreate)openꂽԂł邩ǂB
      * @return Boolean Ay_[悪gp\ǂ
      */
      {
      return !!writer;
      };
    //------------------------------------------------------------------------------
    this.create = function()
     /**
      * Ay_[쐬
      * @explanation Ay_[JOɍ쐬KvꍇɎsB
      */
      {
      if(!this.exists())
        {
        fso.CreateTextFile(fileName, true, charset);
        }
      };
    //------------------------------------------------------------------------------
    this.open = function()
     /**
      * Ay_[J
      * @explanation Ay_[JOɍ쐬Kvꍇ́Acreate\bhsB
      */
      {
      if(!this.isAlive())
        {
        writer = fso.OpenTextFile(fileName, openMode, true, charset);
        }
      };
    //------------------------------------------------------------------------------
    this.print = function(text)
     /**
      * OP
      * @param text String Oo͕
      */
      {
      if(lineSeparator)
        {
        writer.Write(text);
        writer.Write(lineSeparator);
        }
      else
        {
        writer.WriteLine(text);
        }
      };
    //------------------------------------------------------------------------------
    this.close = function()
     /**
      * Ay_[
      */
      {
      writer.Close();
      writer = null;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    fileName      = Static.parseParams(params, "fileName"     , fileName     , "string");
    charset       = Static.parseParams(params, "charset"      , charset      , {ascii:0, ASCII:0, unicode:-1, Unicode:-1, UNICODE:-1});
    lineSeparator = Static.parseParams(params, "lineSeparator", lineSeparator, {CR:"\r", LF:"\n", CRLF:"\r\n", LFCR:"\n\r"});
    openMode      = Static.parseParams(params, "openMode"     , openMode     , {rewrite:2, append:8});
    return this;
    }
  
  return Class;
  }, js.debug.log.AbstractLogAppender);

