Class.create(function(Super)
 /**
  * HTTPOAy_[NX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.log.net.HttpLogAppenderNX
  * 
  * @package js.debug.log.net
  * @update 2007/09/22
  * @version 1.00.00
  * @author Mug
  * @copyright (C) 2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX̓t@Cɑ΂ẴOo͂邽߂̃Ay_[łB</p>
  * @explanation <p>̃NXŋK肷郍Oo͐ݒt@Cł̃p[^[͈ȉ̒ʂB
  *   <dl>
  *     <dt><kbd>url</kbd><em>iK{j</em></dt>
  *     <dd>MURL</dd>
  *     <dt><kbd>username</kbd>iCӁj</dt>
  *     <dd>[U[i{F؂Kvȏꍇɐݒj</dd>
  *     <dt><kbd>password</kbd>iCӁj</dt>
  *     <dd>pX[hi{F؂Kvȏꍇɐݒj</dd>
  *     <dt><kbd>cookie</kbd>iCӁj</dt>
  *     <dd>NbL[̎gp(true|false)</dd>
  *     <dt><kbd>header</kbd>iCӁEj</dt>
  *     <dd>HTTPNGXgwb_iuO: lvݒj</dd>
  *   </dl>
  *   ȂAȊOɂX[p[NX(<var>NetworkLogAppender</var>)Œ`ꂽp[^[ݒ\łB</p>
  * @rel js.debug.log.net.NetworkLogAppender
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.log.net.HttpLogAppender";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V HTTP_METHOD_POST String HTTP\bhPOST
  var HTTP_METHOD_POST = "POST";
  //:V HTTP_STATUS_OK Number Xe[^XR[hOK
  var HTTP_STATUS_OK = 200;
  //:V HTTP_HEADER_PATTERN RegExp HTTPwb_̐K\
  var HTTP_HEADER_PATTERN = /^\s*(\S+?)\s*:\s*(\S+)\s*$/;
  
  //------------------------------------------------------------------------------
  function createHttpRequest(onload)
   /**
    * HTTPNGXgIuWFNg𐶐
    * @param onload [Function] [h̃R[obN֐
    * @return Object|null HTTPNGXgIuWFNg
    */
    {
    var req;
    try
      {
      if((typeof XMLHttpRequest) == "function")
        {
        req = new XMLHttpRequest();
        if((typeof onload) == "function")
          {
          req.onload = function()
            {
            onload.call(req, req);
            };
          }
        }
      else if((typeof ActiveXObject) == "function")
        {
        try
          {
          req = new ActiveXObject("Msxml2.XMLHTTP");
          }
        catch(e)
          {
          try
            {
            req = new ActiveXObject("Microsoft.XMLHTTP");
            }
          catch(e2)
            {
            req = null;
            }
          }
        if(req && ((typeof onload) == "function"))
          {
          req.onreadystatechange = function()
            {
            if(req.readyState == 4)
              {
              onload.call(req, req);
              }
            };
          }
        }
      else
        {
        req = null;
        }
      }
    catch(e)
      {
      req = null;
      }
    return req;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(params)
   /**
    * HttpLogAppenderNX̃RXgN^
    * @param params Object p[^[(String)}bv
    * @return js.debug.log.net.HttpLogAppender CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v hasError Boolean ʐMG[̔L
    var hasError = false;
    //:v isSending Boolean MtO
    var isSending = false;
    //:v que Array|null Mf[^L[
    var que = null;
    
    //:v url String|null MURL
    var url = null;
    //:v usr String|null [U[
    var usr = null;
    //:v pwd String|null pX[h
    var pwd = null;
    //:v cookie Boolean NbL[̎gp
    var cookie = false;
    //:v headers Object NGXgwb_
    var headers = {};
    //:v cookies Object NbL[
    var cookies = {};
    
    //------------------------------------------------------------------------------
    function addHeader(header)
     /**
      * NGXgwb_ǉ
      * @param header String wb_eǉ
      */
      {
      if(((typeof header) == "string") && HTTP_HEADER_PATTERN.test(header))
        {
        HTTP_HEADER_PATTERN.exec(header);
        var key = RegExp.$1;
        var val = RegExp.$2;
        if(!headers[key])
          {
          headers[key] = val;
          }
        else if((typeof headers[key]) == "string")
          {
          headers[key] = [headers[key], val];
          }
        else
          {
          headers[key][headers[key].length] = val;
          }
        }
      }
    //------------------------------------------------------------------------------
    function setCookie(value)
     /**
      * NbL[ݒ肷
      * @param value String X|Xwb_Set-Cookie̒l
      */
      {
      var name, limit, value, options = "";
      var list = value.split(";");
      var COOKIE_UNIT = /^\s*(\S+?)\s*:\s*(\S*)\s*$/;
      for(var i = 0; i < list.length; i++)
        {
        if(COOKIE_UNIT.test(list[i]))
          {
          COOKIE_UNIT.exec(list[i]);
          var key = RegExp.$1;
          var val = RegExp.$2;
          if(key)
            {
            if(i == 0)
              {
              name = key;
              value = val;
              }
            else if((key.toLowerCase() == "expire") || (key.toLowerCase() == "expires"))
              {
              limit = new Date(val);
              }
            else
              {
              if(options)
                {
                options += ";";
                }
              options += key + "=" + val;
              }
            }
          }
        }
      if(name)
        {
        if(limit && (limit.getTime() < (new Date()).getTime()))
          {
          delete cookie[name];
          }
        else
          {
          if(options)
            {
            cookie[name] = value + ";" + options;
            }
          else
            {
            cookie[name] = value;
            }
          }
        }
      }
    //------------------------------------------------------------------------------
    function send()
     /**
      * L[ɒ~ςꂽO𑗐M
      */
      {
      if(hasError || isSending || !que || (que.length == 0))
        {
        return false;
        }
      isSending = true;
      var request = createHttpRequest(onload);
      request.open(HTTP_METHOD_POST, url, true, usr, pwd);
      request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded; charset=UTF-8");
      for(var name in headers)
        {
        if((typeof headers[name]) == "string")
          {
          request.setRequestHeader(name, headers[name]);
          }
        else
          {
          for(var i = 0; i < headers[name].length; i++)
            {
            request.setRequestHeader(name, headers[name][i]);
            }
          }
        }
      if(cookie)
        {
        for(var name in cookie)
          {
          request.setRequestHeader("Cookie", (name + "=" + cookie[name]));
          }
        }
      var data = "";
      for(var i = 0; i < que.length; i++)
        {
        data += que[i] + "\r\n";
        }
      que = null;
      data = encodeURIComponent(data);
      request.send(data);
      function onload(request)
        {
        if(request.status == HTTP_STATUS_OK)
          {
          if(cookie)
            {
            setCookie(request.getResponseHeader("Set-Cookie"));
            }
          isSending = false;
          send();
          }
        else
          {
          isSending = false;
          hasError = true;
          throw new Error("NetworkException", Creator.CompleteName, request.status + ":" + request.statusText);
          }
        }
      }
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.exists = function()
     /**
      * Ay_[悪݂邩ǂ擾
      * @explanation Ay_[݂邩(KvȂcreateĂ邩)ǂB
      * @return Boolean Ay_[悪gp\ǂ
      */
      {
      return true;
      };
    //------------------------------------------------------------------------------
    this.isAlive = function()
     /**
      * Ay_[悪gp\ǂ擾
      * @explanation Ay_[(KvȂcreate)openꂽԂł邩ǂB
      * @return Boolean Ay_[悪gp\ǂ
      */
      {
      return true;
      };
    //------------------------------------------------------------------------------
    this.create = function()
     /**
      * Ay_[쐬
      * @explanation Ay_[JOɍ쐬KvꍇɎsB
      */
      {
      // Do nothing.
      };
    //------------------------------------------------------------------------------
    this.open = function()
     /**
      * Ay_[J
      * @explanation Ay_[JOɍ쐬Kvꍇ́Acreate\bhsB
      */
      {
      // Do nothing.
      };
    //------------------------------------------------------------------------------
    this.print = function(text)
     /**
      * OP
      * @param text String Oo͕
      */
      {
      if(hasError)
        {
        return null;
        }
      if((typeof text) != "string")
        {
        text = "" + text;
        }
      if(!que)
        {
        que = [];
        }
      que[que.length] = text;
      if(!isSending)
        {
        send();
        }
      };
    //------------------------------------------------------------------------------
    this.close = function()
     /**
      * Ay_[
      */
      {
      // Do nothing.
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    url = Static.parseParams(params, "url", null, "string");
    usr = Static.parseParams(params, "username", null, "string");
    pwd = Static.parseParams(params, "password", null, "string");
    cookie = Static.parseParams(params, "cookie", cookie, "boolean");
    (function()
      {
      for(var i = 0; i < arguments.length; i++)
        {
        addHeader(arguments[i]);
        }
      }
    ).apply(this, Static.parseParams(params, "header", null, "string[]"));
    return this;
    }
  
  return Class;
  }, js.debug.log.net.NetworkLogAppender);

